//+------------------------------------------------------------------+
//|                                                  Custom MACD.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
//   
#property  copyright "Copyright  2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 2
#property indicator_level1 0
#property  indicator_color1  Aqua
#property  indicator_color2  Red

extern int WPRperiod=130;
extern int Level=30;
extern int SignalSMA=9;

double K=1.5;
//---- indicator buffers
double     MacdBuffer[];
double     SignalBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexDrawBegin(1,WPRperiod);
   IndicatorDigits(Digits);
//---- indicator buffers mapping
   SetIndexBuffer(0,MacdBuffer);
   SetIndexBuffer(1,SignalBuffer);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("WPR_Country_Area("+WPRperiod+","+Level+")");
   SetIndexLabel(0,"WPR_Country_Area");
   SetIndexLabel(1,"Signal");
   SetIndexEmptyValue( 0,0.0);
   SetIndexEmptyValue( 1,0.0); 

//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   if (limit < 1) limit = 1;
//---- counted in the 1-st buffer
   
   for(int i=limit; i>=0; i--)
      {
      
      double WPR=iWPR(NULL,0,WPRperiod,i);
      //--      
      double WPR100=WPR+100;
      //--      
           
      if(WPR100>=(50+Level))MacdBuffer[i]=MacdBuffer[i+1]+K*(WPR100-(50+Level)); //else MacdBuffer[i]=MacdBuffer[i+1];
      if(WPR100< (50-Level))MacdBuffer[i]=MacdBuffer[i+1]+K*(WPR100-(50-Level));// else MacdBuffer[i]=MacdBuffer[i+1];
      if(WPR100< (50+Level) && WPR100>(50-Level))MacdBuffer[i]=MacdBuffer[i+1]+WPR100-50;
   
      }
   
//---- signal line counted in the 2-nd buffer
   for(i=limit; i>=0; i--)
      SignalBuffer[i]=iMAOnArray(MacdBuffer,Bars,SignalSMA,0,MODE_SMA,i);
//---- done
   return(0);
  }
//+------------------------------------------------------------------+